<script lang="ts">
  import { FormGroup, Input, Label } from "@sveltestrap/sveltestrap";
  import {
    type CheckboxQuestion,
    type ScaleQuestion,
    type SelectQuestion,
    type SurveyQuestion,
    SurveyQuestionType
  } from "@assets/Survey";
  import { getTeammates } from "@models/Team";
  import SurveySwitch from "@components/Survey/SurveySwitch.svelte";
  import { createEventDispatcher, onMount } from "svelte";
  import MultiSelect from "@components/Survey/MultiSelect.svelte";
  import RangeSlider from "@components/Survey/RangeSlider.svelte";
  import { useLocalStorage } from "@components/Utils/useLocalStorage";

  const dispatch = createEventDispatcher();

  let clazz = "";
  export { clazz as class };
  export let entry: SurveyQuestion;
  export let teamId: string;

  /*
   * All inputs should bind to value, then the onChange function
   * will dispatch an event with the stringified value.
   * This way can bind various data types within this component,
   * but always return a string to the parent.
   */
  let storedAnswer = useLocalStorage(entry.prompt, undefined);

  onMount(() => {
    // if the initial value is not undefined, trigger an update in the parent
    if ($storedAnswer !== undefined) {
      onChange();
    }
  });

  function onChange() {
    dispatch("change", {
      question: entry,
      answer: JSON.stringify($storedAnswer)
    });
  }

  async function castSelect(question: SurveyQuestion) {
    return question as SelectQuestion;
  }

  async function castCheckbox(question: SurveyQuestion) {
    return question as CheckboxQuestion;
  }

  async function castScale(question: SurveyQuestion) {
    return question as ScaleQuestion;
  }
</script>

{#if entry.type === SurveyQuestionType.Switch}
  <FormGroup>
    <SurveySwitch
      id={entry.prompt}
      label={entry.prompt}
      on:change={onChange}
      bind:checked={$storedAnswer}
    />
  </FormGroup>


{:else if entry.type === SurveyQuestionType.Select}
  {#await castSelect(entry) then question}
    <FormGroup>
      <Label for={entry.prompt}>{entry.prompt}</Label>
      <Input
        id={entry.prompt}
        type="select"
        bind:value={$storedAnswer}
        on:change={onChange}
      >
        <!-- provide a default blank value -->
        <option selected disabled></option>
        {#each question.meta.options as value}
          <option value={value}>{value}</option>
        {/each}
      </Input>
    </FormGroup>
  {/await}


{:else if entry.type === SurveyQuestionType.Checkbox}
  {#await castCheckbox(entry) then question}
    <FormGroup>
      <MultiSelect
        label={entry.prompt}
        bind:value={$storedAnswer}
        on:change={onChange}
        options={question.meta?.options}
        max={question.meta.maxSelections}
      />
    </FormGroup>
  {/await}

{:else if entry.type === SurveyQuestionType.ShortText}
  <FormGroup floating label="{entry.prompt}">
    <Input
      class="{clazz}"
      on:change={onChange}
      bind:value={$storedAnswer} />
  </FormGroup>


{:else if entry.type === SurveyQuestionType.LongText}
  <FormGroup class="d-flex flex-column-reverse" label="{entry.prompt}">
    <Input
      class="{clazz}"
      style="min-height: 7.5em /* min height is a replacement for rows= /"
      type="textarea"
      on:change={onChange}
      bind:value={$storedAnswer}
    />
  </FormGroup>

{:else if entry.type === SurveyQuestionType.SelectTeamMember}
  <FormGroup class="d-flex flex-column-reverse gap-1" label={entry.prompt}>
    {#await getTeammates(teamId) then teammates}
      <Input on:change={onChange} type="select" bind:value={$storedAnswer}>
        <option value={undefined} disabled selected>Select a teammate</option>
        {#each teammates as user}
          <option value={user.id}>{user.first_name} {user.last_name}</option>
        {/each}
      </Input>
    {:catch _}
      <p>Failed to load teammates</p>
    {/await}
  </FormGroup>
{:else if entry.type === SurveyQuestionType.Scale}
  {#await castScale(entry) then question}
    <FormGroup label={question.prompt} class="d-flex flex-column-reverse">
      <RangeSlider
        {onChange}
        min={question.meta.min}
        max={question.meta.max}
        minLabel={question.meta.minLabel}
        maxLabel={question.meta.maxLabel}
        maxSuffix={question.meta.maxSuffix}
        bind:value={$storedAnswer}
      />
    </FormGroup>
  {/await}
{/if}
